import { Request, Response } from '@types/express';
import Status from './Status';
import Session from './Session';

export default class Transaction {
  /* private */
  private _req: Request;
  private _res: Response;
  private _status: Status;

  /* public */
  public get req (): Request { return this._req; }
  public get res (): Response { return this._res; }
  public get status (): Status { return this._status; }
  public session: Session;

  /* constructor */
  public constructor (req: Request, res: Response) {
    this._req = req;
    this._res = res;
    this._status = new Status;
  }

  /* methods */
  public finalize (): void {
    if (this._status.has_status ())
      this._res.status (this.status.status);
    this._res.end (data);
  }
}
